package bip.gwm.scm.settlement.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.math.BigInteger;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Security;
import java.security.Signature;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.Arrays;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.gm.GMNamedCurves;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.crypto.digests.SM3Digest;
import org.bouncycastle.crypto.engines.SM2Engine;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithRandom;
import org.bouncycastle.jcajce.provider.asymmetric.ec.BCECPrivateKey;
import org.bouncycastle.jcajce.provider.asymmetric.ec.BCECPublicKey;
import org.bouncycastle.jcajce.spec.SM2ParameterSpec;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECParameterSpec;
import org.bouncycastle.jce.spec.ECPrivateKeySpec;
import org.bouncycastle.jce.spec.ECPublicKeySpec;
import org.bouncycastle.util.encoders.Base64;
import org.bouncycastle.util.encoders.Hex;

public class DecryptDemoV1 {

   private static X9ECParameters x9ECParameters = GMNamedCurves.getByName("sm2p256v1");
   private static ECDomainParameters ecDomainParameters = new ECDomainParameters(x9ECParameters.getCurve(), x9ECParameters.getG(), x9ECParameters.getN());
   private static ECParameterSpec ecParameterSpec = new ECParameterSpec(x9ECParameters.getCurve(), x9ECParameters.getG(), x9ECParameters.getN());
   private static final int RS_LEN = 32;
   public static final String USER_ID = "1234567812345678";
   public static final byte[] SM4_CBC_IV;


   public static void CmbEncDecyTest() throws Exception {
      BigInteger d = new BigInteger("9a74f839a4079cbed06d2a6cbdbed344d32dd0b65de214db9c96d0023267c093", 16);
      BCECPrivateKey bcecPrivateKey = getPrivatekeyFromD(d);
      String oldString = "Ylbxd5qemka7OAlo4mofjCCcToEn8a7EShqrHcx7ms1P8WKrqG\\/ka23v5pZpV+\\/NnvdIeDTPvV69g5YUmVubliNBQT+RXVBeTJpnhGyXdauMDyj85gd6PTdacKXR\\/e5pgGdyfyoZIgYmnnw2BUxLcsSijd2dTRggd\\/aCFP9sQcFaQuWXopqqZbGfLb3OnLJcB6WGjXHPQqloYLlma+KOjBczLT72gRwMPzKLNVZjANbnRvNKUOC0CzLNDcju8aRnlb51JsMxLtg5czy5VaTCFQi+SeDm4wG\\/ShSQf\\/wCP2xpj1j4sdsu4f6XXEZj6sYhheYGgqSVeL4RY24F3mGRtwS3SeHKIVzcDbmKm\\/6Ivh9jYOUXb1+LQ0kKp7klfS0PsniBNgSwJ8M1MkXiFr82PFHnl2SNUWF0S0obdXL0\\/fFYUuz+b\\/xOfW8XNdjBkOQgQGY+fryyJtQLcByYnHXyB6V7K1UO\\/HUj3lwHibVGex\\/Vltue+V6fcMkGFevJO07YfmDso9orA6eTUgUAlMOs8w==".replace("\\", "");
      String newString = "MHkCIGqjoDLAWaWD2FxkxCMInQzedI2wY7JwY3Ub\\/XOWD\\/IYAiEAkEUjC8iye1Io6RzlYH\\/gJnjA0VnuC+Z65mwd7dGjf3AEIMZFosH+0wr5+PRc\\/tV9Sw2yXJDhWfkYh9hAdgrQSEakBBDg2wra9LaWrk+0lYXRqIq9".replace("\\", "");
      String[] zCipTxt = new String[]{oldString};
      byte[] wDigEvpByt = Base64.decode(newString.getBytes());
      byte[] wDigEvpByt3 = cipherAsn1ToRaw(wDigEvpByt);
      System.out.println("HEX DEBUG:" + new String(Hex.encode(wDigEvpByt3)));
      byte[] wOriKeyByt = sm2DecryptOld(wDigEvpByt3, bcecPrivateKey);
      System.out.println("解密出来的明文SM4密钥长度:" + wOriKeyByt.length);
      if(zCipTxt.length > 1) {
         String[] wEncByt2 = zCipTxt;
         int bs = zCipTxt.length;

         for(int t = 0; t < bs; ++t) {
            String z = wEncByt2[t];
            byte[] wEncByt21 = Base64.decode(z.getBytes());
            byte[] bs1 = new byte[wOriKeyByt.length];
            System.arraycopy(wOriKeyByt, 0, bs1, 0, wOriKeyByt.length);
            byte[] t1 = java.util.Base64.getDecoder().decode(new String(sm4DecryptCBC(wOriKeyByt, wEncByt21, SM4_CBC_IV), "UTF-8"));
            System.out.println("解密出来的明文:" + new String(t1, "UTF-8"));
         }
      } else {
         byte[] var16 = Base64.decode(zCipTxt[0].getBytes());
         byte[] var17 = new byte[wOriKeyByt.length];
         System.arraycopy(wOriKeyByt, 0, var17, 0, wOriKeyByt.length);
         byte[] var18 = java.util.Base64.getDecoder().decode(new String(sm4DecryptCBC(wOriKeyByt, var16, SM4_CBC_IV), "UTF-8"));
         System.out.println("解密出来的明文:" + new String(var18, "UTF-8"));
      }

   }

   public static void main(String[] args) throws Exception {
      long start2 = System.currentTimeMillis();
      CmbEncDecyTest();
      System.out.println("CmbEncDecyTest consumes " + (System.currentTimeMillis() - start2) + "ms");
   }

   public static byte[] signSm3WithSm2(byte[] msg, byte[] userId, PrivateKey privateKey) {
      return rsAsn1ToPlainByteArray(signSm3WithSm2Asn1Rs(msg, userId, privateKey));
   }

   public static byte[] signSm3WithSm2Asn1Rs(byte[] msg, byte[] userId, PrivateKey privateKey) {
      try {
         SM2ParameterSpec e = new SM2ParameterSpec(userId);
         Signature signer = Signature.getInstance("SM3withSM2", "BC");
         signer.setParameter(e);
         signer.initSign(privateKey, new SecureRandom());
         signer.update(msg, 0, msg.length);
         byte[] sig = signer.sign();
         return sig;
      } catch (Exception var6) {
         throw new RuntimeException(var6);
      }
   }

   public static boolean verifySm3WithSm2(byte[] msg, byte[] userId, byte[] rs, PublicKey publicKey) {
      return verifySm3WithSm2Asn1Rs(msg, userId, rsPlainByteArrayToAsn1(rs), publicKey);
   }

   public static boolean verifySm3WithSm2Asn1Rs(byte[] msg, byte[] userId, byte[] rs, PublicKey publicKey) {
      try {
         SM2ParameterSpec e = new SM2ParameterSpec(userId);
         Signature verifier = Signature.getInstance("SM3withSM2", "BC");
         verifier.setParameter(e);
         verifier.initVerify(publicKey);
         verifier.update(msg, 0, msg.length);
         return verifier.verify(rs);
      } catch (Exception var6) {
         throw new RuntimeException(var6);
      }
   }

   private static byte[] changeC1C2C3ToC1C3C2(byte[] c1c2c3) {
      int c1Len = (x9ECParameters.getCurve().getFieldSize() + 7) / 8 * 2 + 1;
      boolean c3Len = true;
      byte[] result = new byte[c1c2c3.length];
      System.arraycopy(c1c2c3, 0, result, 0, c1Len);
      System.arraycopy(c1c2c3, c1c2c3.length - 32, result, c1Len, 32);
      System.arraycopy(c1c2c3, c1Len, result, c1Len + 32, c1c2c3.length - c1Len - 32);
      return result;
   }

   private static byte[] changeC1C3C2ToC1C2C3(byte[] c1c3c2) {
      int c1Len = (x9ECParameters.getCurve().getFieldSize() + 7) / 8 * 2 + 1;
      boolean c3Len = true;
      byte[] result = new byte[c1c3c2.length];
      System.arraycopy(c1c3c2, 0, result, 0, c1Len);
      System.arraycopy(c1c3c2, c1Len + 32, result, c1Len, c1c3c2.length - c1Len - 32);
      System.arraycopy(c1c3c2, c1Len, result, c1c3c2.length - 32, 32);
      return result;
   }

   public static byte[] sm2Decrypt(byte[] data, PrivateKey key) {
      return sm2DecryptOld(changeC1C3C2ToC1C2C3(data), key);
   }

   public static byte[] sm2EncryptOld(byte[] data, PublicKey key) {
      BCECPublicKey localECPublicKey = (BCECPublicKey)key;
      ECPublicKeyParameters ecPublicKeyParameters = new ECPublicKeyParameters(localECPublicKey.getQ(), ecDomainParameters);
      SM2Engine sm2Engine = new SM2Engine();
      sm2Engine.init(true, new ParametersWithRandom(ecPublicKeyParameters, new SecureRandom()));

      try {
         return sm2Engine.processBlock(data, 0, data.length);
      } catch (InvalidCipherTextException var6) {
         throw new RuntimeException(var6);
      }
   }

   public static byte[] sm2DecryptOld(byte[] data, PrivateKey key) {
      BCECPrivateKey localECPrivateKey = (BCECPrivateKey)key;
      ECPrivateKeyParameters ecPrivateKeyParameters = new ECPrivateKeyParameters(localECPrivateKey.getD(), ecDomainParameters);
      SM2Engine sm2Engine = new SM2Engine();
      sm2Engine.init(false, ecPrivateKeyParameters);

      try {
         return sm2Engine.processBlock(data, 0, data.length);
      } catch (InvalidCipherTextException var6) {
         throw new RuntimeException(var6);
      }
   }

   public static byte[] sm4Encrypt(byte[] keyBytes, byte[] plain) {
      if(keyBytes.length != 16) {
         throw new RuntimeException("err key length");
      } else if(plain.length % 16 != 0) {
         throw new RuntimeException("err data length");
      } else {
         try {
            SecretKeySpec e = new SecretKeySpec(keyBytes, "SM4");
            Cipher out = Cipher.getInstance("SM4/ECB/NoPadding", "BC");
            out.init(1, e);
            return out.doFinal(plain);
         } catch (Exception var4) {
            throw new RuntimeException(var4);
         }
      }
   }

   public static byte[] sm4Decrypt(byte[] keyBytes, byte[] cipher) {
      if(keyBytes.length != 16) {
         throw new RuntimeException("err key length");
      } else if(cipher.length % 16 != 0) {
         throw new RuntimeException("err data length");
      } else {
         try {
            SecretKeySpec e = new SecretKeySpec(keyBytes, "SM4");
            Cipher in = Cipher.getInstance("SM4/ECB/NoPadding", "BC");
            in.init(2, e);
            return in.doFinal(cipher);
         } catch (Exception var4) {
            throw new RuntimeException(var4);
         }
      }
   }

   public static byte[] sm4EncryptCBC(byte[] keyBytes, byte[] plain, byte[] iv) {
      if(keyBytes.length != 16) {
         throw new RuntimeException("err key length");
      } else {
         try {
            SecretKeySpec e = new SecretKeySpec(keyBytes, "SM4");
            Cipher out = Cipher.getInstance("SM4/CBC/PKCS5Padding", "BC");
            IvParameterSpec ivSpec = new IvParameterSpec(iv);
            out.init(1, e, ivSpec);
            return out.doFinal(plain);
         } catch (Exception var6) {
            throw new RuntimeException(var6);
         }
      }
   }

   public static byte[] sm4DecryptCBC(byte[] keyBytes, byte[] cipher, byte[] iv) {
      if(keyBytes.length != 16) {
         throw new RuntimeException("err key length");
      } else {
         try {
            SecretKeySpec e = new SecretKeySpec(keyBytes, "SM4");
            Cipher in = Cipher.getInstance("SM4/CBC/PKCS5Padding", "BC");
            IvParameterSpec ivSpec = new IvParameterSpec(iv);
            in.init(2, e, ivSpec);
            return in.doFinal(cipher);
         } catch (Exception var6) {
            throw new RuntimeException(var6);
         }
      }
   }

   public static byte[] sm3(byte[] bytes) {
      SM3Digest sm3 = new SM3Digest();
      sm3.update(bytes, 0, bytes.length);
      byte[] result = new byte[sm3.getDigestSize()];
      sm3.doFinal(result, 0);
      return result;
   }

   private static byte[] bigIntToFixexLengthBytes(BigInteger rOrS) {
      byte[] rs = rOrS.toByteArray();
      if(rs.length == 32) {
         return rs;
      } else if(rs.length == 33 && rs[0] == 0) {
         return Arrays.copyOfRange(rs, 1, 33);
      } else if(rs.length < 32) {
         byte[] result = new byte[32];
         Arrays.fill(result, (byte)0);
         System.arraycopy(rs, 0, result, 32 - rs.length, rs.length);
         return result;
      } else {
         throw new RuntimeException("err rs: " + Hex.toHexString(rs));
      }
   }

   private static byte[] rsAsn1ToPlainByteArray(byte[] rsDer) {
      ASN1Sequence seq = ASN1Sequence.getInstance(rsDer);
      byte[] r = bigIntToFixexLengthBytes(ASN1Integer.getInstance(seq.getObjectAt(0)).getValue());
      byte[] s = bigIntToFixexLengthBytes(ASN1Integer.getInstance(seq.getObjectAt(1)).getValue());
      byte[] result = new byte[64];
      System.arraycopy(r, 0, result, 0, r.length);
      System.arraycopy(s, 0, result, 32, s.length);
      return result;
   }

   private static byte[] rsPlainByteArrayToAsn1(byte[] sign) {
      if(sign.length != 64) {
         throw new RuntimeException("err rs. ");
      } else {
         BigInteger r = new BigInteger(1, Arrays.copyOfRange(sign, 0, 32));
         BigInteger s = new BigInteger(1, Arrays.copyOfRange(sign, 32, 64));
         ASN1EncodableVector v = new ASN1EncodableVector();
         v.add(new ASN1Integer(r));
         v.add(new ASN1Integer(s));

         try {
            return (new DERSequence(v)).getEncoded("DER");
         } catch (IOException var5) {
            throw new RuntimeException(var5);
         }
      }
   }

   public static KeyPair generateKeyPair() {
      try {
         KeyPairGenerator e = KeyPairGenerator.getInstance("EC", "BC");
         e.initialize(ecParameterSpec, new SecureRandom());
         KeyPair kp = e.generateKeyPair();
         return kp;
      } catch (Exception var2) {
         throw new RuntimeException(var2);
      }
   }

   public static BCECPrivateKey getPrivatekeyFromD(BigInteger d) {
      ECPrivateKeySpec ecPrivateKeySpec = new ECPrivateKeySpec(d, ecParameterSpec);
      return new BCECPrivateKey("EC", ecPrivateKeySpec, BouncyCastleProvider.CONFIGURATION);
   }

   public static BCECPublicKey getPublickeyFromXY(BigInteger x, BigInteger y) {
      ECPublicKeySpec ecPublicKeySpec = new ECPublicKeySpec(x9ECParameters.getCurve().createPoint(x, y), ecParameterSpec);
      return new BCECPublicKey("EC", ecPublicKeySpec, BouncyCastleProvider.CONFIGURATION);
   }

   public static PublicKey getPublickeyFromX509File(File file) {
      try {
         CertificateFactory e = CertificateFactory.getInstance("X.509", "BC");
         FileInputStream in = new FileInputStream(file);
         X509Certificate x509 = (X509Certificate)e.generateCertificate(in);
         return x509.getPublicKey();
      } catch (Exception var4) {
         throw new RuntimeException(var4);
      }
   }

   public static byte[] cipherRawToAsn1(byte[] bcCipTxt) throws Exception {
      int bcCipLen = bcCipTxt.length - 1;
      if(96 >= bcCipLen) {
         throw new Exception("RAW ciphertext length error:" + bcCipLen);
      } else {
         int C3Len = bcCipLen - 96;
         byte[] keyX = new byte[32];
         byte[] keyY = new byte[32];
         byte[] C3 = new byte[C3Len];
         byte[] C2 = new byte[32];
         System.arraycopy(bcCipTxt, 1, keyX, 0, 32);
         System.arraycopy(bcCipTxt, 33, keyY, 0, 32);
         System.arraycopy(bcCipTxt, 65, C3, 0, C3Len);
         System.arraycopy(bcCipTxt, 65 + C3Len, C2, 0, 32);
         byte[] netSignCipTxt = new byte[bcCipLen + 13];
         int wPos = 4;
         netSignCipTxt[0] = 48;
         netSignCipTxt[2] = 2;
         if((keyX[0] & 255) >= 128) {
            netSignCipTxt[wPos - 1] = 33;
            netSignCipTxt[wPos] = 0;
            ++wPos;
         } else {
            netSignCipTxt[wPos - 1] = 32;
         }

         System.arraycopy(keyX, 0, netSignCipTxt, wPos, 32);
         wPos += 32;
         netSignCipTxt[wPos] = 2;
         ++wPos;
         if((keyY[0] & 255) >= 128) {
            netSignCipTxt[wPos] = 33;
            ++wPos;
            netSignCipTxt[wPos] = 0;
            ++wPos;
         } else {
            netSignCipTxt[wPos] = 32;
            ++wPos;
         }

         System.arraycopy(keyY, 0, netSignCipTxt, wPos, 32);
         wPos += 32;
         netSignCipTxt[wPos] = 4;
         ++wPos;
         netSignCipTxt[wPos] = 32;
         ++wPos;
         System.arraycopy(C2, 0, netSignCipTxt, wPos, 32);
         wPos += 32;
         netSignCipTxt[wPos] = 4;
         ++wPos;
         netSignCipTxt[wPos] = (byte)C3Len;
         ++wPos;
         System.arraycopy(C3, 0, netSignCipTxt, wPos, C3Len);
         wPos += C3Len;
         netSignCipTxt[1] = (byte)(wPos - 2);
         byte[] resultBytes = new byte[wPos];
         System.arraycopy(netSignCipTxt, 0, resultBytes, 0, wPos);
         return resultBytes;
      }
   }

   public static byte[] cipherAsn1ToRaw(byte[] asn1CipTxt) throws Exception {
      byte wPos = 3;
      int var8;
      if((asn1CipTxt[wPos] & 255) == 32) {
         var8 = wPos + 1;
      } else {
         if((asn1CipTxt[wPos] & 255) != 33) {
            throw new Exception("keyX length Error!");
         }

         var8 = wPos + 2;
      }

      byte[] keyX = new byte[32];
      System.arraycopy(asn1CipTxt, var8, keyX, 0, 32);
      var8 += 32;
      ++var8;
      if((asn1CipTxt[var8] & 255) == 32) {
         ++var8;
      } else {
         if((asn1CipTxt[var8] & 255) != 33) {
            throw new Exception("keyY length Error!");
         }

         var8 += 2;
      }

      byte[] keyY = new byte[32];
      System.arraycopy(asn1CipTxt, var8, keyY, 0, 32);
      var8 += 32;
      ++var8;
      if((asn1CipTxt[var8] & 255) == 32) {
         ++var8;
         byte[] C2 = new byte[32];
         System.arraycopy(asn1CipTxt, var8, C2, 0, 32);
         var8 += 32;
         ++var8;
         int C3Len = asn1CipTxt[var8] & 255;
         if(0 < C3Len) {
            ++var8;
            byte[] C3 = new byte[C3Len];
            System.arraycopy(asn1CipTxt, var8, C3, 0, C3Len);
            int var10000 = var8 + C3Len;
            byte[] resultBytes = new byte[97 + C3Len];
            resultBytes[0] = 4;
            System.arraycopy(keyX, 0, resultBytes, 1, 32);
            System.arraycopy(keyY, 0, resultBytes, 33, 32);
            System.arraycopy(C3, 0, resultBytes, 65, C3Len);
            System.arraycopy(C2, 0, resultBytes, 65 + C3Len, 32);
            return resultBytes;
         } else {
            throw new Exception("C3 length Error!");
         }
      } else {
         throw new Exception("C2 length Error!");
      }
   }

   public static String CmbEncDecy(String privateKey, String zCipTxt, String zDigEvp) throws Exception {
      String r = "{}";
      BigInteger d = new BigInteger(privateKey, 16);
      BCECPrivateKey bcecPrivateKey = getPrivatekeyFromD(d);
      byte[] wDigEvpByt = Base64.decode(zDigEvp.getBytes());
      byte[] wDigEvpByt3 = cipherAsn1ToRaw(wDigEvpByt);
      byte[] wOriKeyByt = sm2DecryptOld(wDigEvpByt3, bcecPrivateKey);
      byte[] wEncByt2 = Base64.decode(zCipTxt.getBytes());
      byte[] t = java.util.Base64.getDecoder().decode(new String(sm4DecryptCBC(wOriKeyByt, wEncByt2, SM4_CBC_IV), "UTF-8"));
      r = new String(t, "UTF-8");
      return r;
   }

   static {
      if(Security.getProvider("BC") == null) {
         Security.addProvider(new BouncyCastleProvider());
      }

      SM4_CBC_IV = new byte[]{(byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0};
   }
}
